
#include <stdio.h>

#define W(arg) fprintf(outfile, "%s", arg)
#define WF(for, arg...) fprintf(outfile, for, arg)

int quantisers[42] = 
{
	1, 2, 3, 4, 5, 6, 7, 8, 10, 12, 14, 16, 18, 20, 22, 24, 26, 28, 30, 32,
	34, 36, 38, 40, 42, 44, 46, 48, 50, 52, 54, 56, 58, 60, 62, 64, 72, 80,
	88, 96, 104, 112
};

int main (int argc, const char * argv[])
{
	FILE *outfile;
	int i, j, k, q, nq, t;
	int alt_table = 0;
	int fill_table = 1;
	
	if (argc != 3) return 2;
	
	if (strcmp(argv[1], "norm") == 0) alt_table = 0;
	else if (strcmp(argv[1], "alt") == 0) alt_table = 1;
	else if (strcmp(argv[1], "run") == 0) fill_table = 0;
	else return 3;
	
	outfile = fopen(argv[2], "w");
	if (!outfile) return 4;
	
	W("static short quant_equ[113] = {\n");
	j = 0;
	q = quantisers[j];
	for (i = 0; i <= 112; i++)
	{
		while(i > q)
		{
			j++;
			q = quantisers[j];
		}

		WF(" %i", j);
		if (i != 112) W(",");
		if (i && (i % 10 == 0)) W("\n");
	}
	W("\n};\n\n");
	
	for (i = 0; i < 42; i++)
	{
		q = quantisers[i];
		
		for (j = i + 1; j < 42; j++)
		{
			nq = quantisers[j];
		
			if (fill_table)
			{
				WF("static short quant_table_%i_to_%i[4096] = {\n", q, nq);
				
				for (k = -2048; k <= 2047; k++)
				{
					t = (k*q) / nq;
				
					if (alt_table)
					{
						int t2, t3;
						int d, d2, d3;
						
						t2 = t + 1;
						t3 = t - 1;
						
						d = abs((t * nq) - (k*q));
						d2 = abs((t2 * nq) - (k*q));
						d3 = abs((t3 * nq) - (k*q));
						
						if (d2 < d) { d = d2; t = t2; }
						if (d3 < d) t = t3;
					}
		
					if (t > 2047) t = 2047;
					if (t < -2048) t = -2048;
		
					WF(" %i", t);
					if (k != 2047) W(",");
					if ((k + 2048) && ((k + 2048) % 10 == 0)) W("\n");
				}
				
				W("\n};\n\n");
			}
			else
				WF("static short quant_table_%i_to_%i[4096];\n", q, nq);
		}
	}
	
	W("static short *quant_tables[42][42] = {\n");
	for (i = 0; i < 42; i++)
	{
		q = quantisers[i];
		W("{ ");
		for (j = 0; j < 42; j++)
		{
			nq = quantisers[j];
			if (j > i) WF(" &quant_table_%i_to_%i[2048]", q, nq);
			else W("0");
			
			if (j != 41) W(",");
			if ((j > i) && (j % 4 == 0)) W("\n");
		}
		if (i != 41) W("},\n");
		else W("}");
	}
	W("\n};\n\n");

	fclose(outfile);
	return 0;
}



